/*! Copyright 2013 Amazon Digital Services, Inc. All rights reserved. */
APICallHandler=(function(){var c=function(o,l,n){var q=o;var p=l;var k=n;var m="APICall";this["getHandledType"]=function(){return m};this["handleRequest"]=function(t){var O=$.Deferred();if(!(t instanceof Request)){console.log("APICallHandler: handleRequest: input was not of type Request");var E=new Result(constants.NativeCallResultCode.ERROR,{});O.resolve(E)}else{var s=t.getType();var P=t.getParams();console.log("APICallHandler: handleRequest: message is: "+JSON.stringify(P));var v=""+P[constants.ServiceActionCode.ACTION_CODE_KEY];var F={};switch(v){case constants.ServiceActionCode.AUTHORIZE_SESSION:q.onInitialize();q.getInitializationPromise().always(function(){var Q={};Q[constants.BindingKeys.AUTHORIZE_RESULT_BUNDLE_KEY]=constants.AuthorizeKeys.AUTHORIZED;var R=constants.NativeCallResultCode.SUCCESS;var S=new Result(R,Q);O.resolve(S)});break;case constants.ServiceActionCode.START_SESSION:p.startSession();q.startSession();var J=new Result(constants.NativeCallResultCode.SUCCESS,{});O.resolve(J);break;case constants.ServiceActionCode.STOP_SESSION:p.stopSession();var J=new Result(constants.NativeCallResultCode.SUCCESS,{});O.resolve(J);break;case constants.ServiceActionCode.SHOW_SIGN_IN_PAGE:q.showSignInPage();var J=new Result(constants.NativeCallResultCode.SUCCESS,{});O.resolve(J);break;case constants.ServiceActionCode.SHOW_TOS_PAGE:q.showOverlay(constants.OverlayActionCode.SHOW_TERMS_OF_SERVICE);var J=new Result(constants.NativeCallResultCode.SUCCESS,{});O.resolve(J);break;case constants.ServiceActionCode.SET_OPT_IN:var u=P[constants.NativeCallKeys.HAS_OPTED_IN];q.setOptIn(u);J=new Result(constants.NativeCallResultCode.SUCCESS,{});O.resolve(J);break;case constants.ServiceActionCode.AUTHENTICATE:q.authenticate();var J=new Result(constants.NativeCallResultCode.SUCCESS,{});O.resolve(J);break;case constants.ServiceActionCode.UPDATE_COUNTRY_OF_RESIDENCE:q.updateCOR(t.getParams()[constants.BindingKeys.COUNTRY_OF_RESIDENCE]);var J=new Result(constants.NativeCallResultCode.SUCCESS,{});O.resolve(J);break;case constants.ServiceActionCode.IS_WHISPERSYNC_ENABLED:k.getGuestMode().always(function(Q){k.isKindle().always(function(S){var R=$.Deferred();if(S){k.isKindleWhispersyncSettingEnabled().always(function(T){R.resolve(T)})}else{k.getWhispersyncEnabledUserSetting().always(function(T){R.resolve(T)})}R.always(function(U){var T={};if(Q||!U){T[constants.BindingKeys.WHISPERSYNC_ENABLED]=false}else{T[constants.BindingKeys.WHISPERSYNC_ENABLED]=true}var V=new Result(constants.NativeCallResultCode.SUCCESS,T);O.resolve(V)})})});break;case constants.ServiceActionCode.SHOW_OVERLAY_ACHIEVEMENTS:var N={};N[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_ACHIEVEMENTS;hostinterface.showOverlay(JSON.stringify(N));break;case constants.ServiceActionCode.SHOW_OVERLAY_PROFILE:var N={};N[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_PROFILE;hostinterface.showOverlay(JSON.stringify(N));break;case constants.ServiceActionCode.SHOW_OVERLAY_LEADERBOARDS:case constants.ServiceActionCode.SHOW_OVERLAY_RANKS:var N={};N[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_LEADERBOARDS;N[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=t.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY];hostinterface.showOverlay(JSON.stringify(N));break;case constants.ServiceActionCode.SHOW_OVERLAY_SUMMARY:var N={};N[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_SUMMARY;hostinterface.showOverlay(JSON.stringify(N));break;case constants.ServiceActionCode.HANDLE_TOAST_CLICK:var F={};var D=t.getParams()[constants.ToastKeys.ACTION_MAPPINGS_KEY];var M=t.getParams()[constants.ToastKeys.TOAST_CLICK_DATA_KEY];var L=ServiceFactory.getRequestFactory().createToastClickRequest(D,M);ServiceFactory.getRequestRouter().handleRequest(L).always(function(Q){O.resolve({})});break;case constants.ServiceActionCode.HANDLE_TOAST_DISPLAY_METRIC:var F={};var z=t.getParams()[constants.ToastKeys.TOAST_REQUEST_DISPLAYED];var C=ServiceFactory.getRequestFactory().createToastMetricRequest(z);ServiceFactory.getRequestRouter().handleRequest(C).always(function(Q){O.resolve({})});break;case constants.ServiceActionCode.PROCESS_OFFLINE_EVENT:var F={};var x=ServiceFactory.getRequestFactory().createProcessOfflineEventRequest(t.getParams()["jsonEvent"]);ServiceFactory.getRequestRouter().handleRequest(x).always(function(Q){O.resolve(i(Q))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENT:var I=ServiceFactory.getRequestFactory().createGetAchievementRequest(t.getParams()["ACHIEVEMENT_ID"],false);var H=ServiceFactory.getRequestRouter().handleRequest(I);H.done(function(Q){O.resolve(h(Q))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENTS:var K=ServiceFactory.getRequestFactory().createGetAchievementsRequest(false);var H=ServiceFactory.getRequestRouter().handleRequest(K);H.done(function(Q){O.resolve(a(Q))});break;case constants.ServiceActionCode.UPDATE_ACHIEVEMENT_PROGRESS:var w=ServiceFactory.getRequestFactory().createUpdateAchievementsRequest(t.getParams()["ACHIEVEMENT_ID"],t.getParams()["ACHIEVEMENT_UPDATE_PERCENT"]);var H=ServiceFactory.getRequestRouter().handleRequest(w);H.done(function(Q){O.resolve(e(Q))});break;case constants.ServiceActionCode.REQUEST_LEADERBOARDS:var y=ServiceFactory.getRequestFactory().createGetLeaderboardsForGameRequest(t.getParams()["GAME_ID"],false);var H=ServiceFactory.getRequestRouter().handleRequest(y);H.done(function(Q){O.resolve(j(Q))});break;case constants.ServiceActionCode.REQUEST_PLAYER_SCORE:var r=ServiceFactory.getRequestFactory().createGetHighScoreRequest(t.getParams()["GAME_ID"],t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_FILTER"],false);var H=ServiceFactory.getRequestRouter().handleRequest(r);H.done(function(Q){O.resolve(d(Q))});break;case constants.ServiceActionCode.REQUEST_SCORES:t.getParams()["LEADERBOARD_START_RANK"]=1;t.getParams()["LEADERBOARD_SCORES_COUNT"]=100;var B=ServiceFactory.getRequestFactory().createGetLeaderboardRanksRequest(t.getParams()["GAME_ID"],t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_FILTER"],t.getParams()["LEADERBOARD_START_RANK"],t.getParams()["LEADERBOARD_SCORES_COUNT"],false,false);var H=ServiceFactory.getRequestRouter().handleRequest(B);H.done(function(Q){O.resolve(f(Q,t.getParams()["LEADERBOARD_START_RANK"]))});break;case constants.ServiceActionCode.REQUEST_PERCENTILES:var A=ServiceFactory.getRequestFactory().createGetLeaderboardPercentilesRequest(t.getParams()["GAME_ID"],t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_FILTER"],false,false);var H=ServiceFactory.getRequestRouter().handleRequest(A);H.done(function(Q){O.resolve(g(Q))});break;case constants.ServiceActionCode.SUBMIT_SCORE:var G=ServiceFactory.getRequestFactory().createSubmitScoreRequest(t.getParams()["LEADERBOARD_ID"],t.getParams()["LEADERBOARD_SUBMIT_SCORE"]);var H=ServiceFactory.getRequestRouter().handleRequest(G);H.done(function(Q){O.resolve(b(Q,t.getParams()["LEADERBOARD_SUBMIT_SCORE"]))});break;case constants.ServiceActionCode.REQUEST_LOCAL_PLAYER_PROFILE:k.getGuestMode().always(function(T){if(T){var Q={};Q[constants.BindingKeys.REQUEST_ID_KEY]=t.getParams()[constants.BindingKeys.REQUEST_ID_KEY];Q[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(Q))}else{var R="https://cortana-gateway.amazon.com/cortana/gateway/profile/";var S=NativeTransport.serviceCall({target:"ProfilesService",method:"getDefaultProfile",httpMethod:"GET",endPoint:R});S.done(function(V){if(V.hidden){var U={};U[constants.BindingKeys.REQUEST_ID_KEY]=t.getParams()[constants.BindingKeys.REQUEST_ID_KEY];U[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(U))}else{var U={};U[constants.BindingKeys.REQUEST_ID_KEY]=t.getParams()[constants.BindingKeys.REQUEST_ID_KEY];U[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_SUCCESS;U[constants.ProfilesBindingKeys.ALIAS_KEY]=V.alias;U[constants.ProfilesBindingKeys.PLAYER_ID_KEY]=V.playerId;console.log("DEBUG: Profile response: "+JSON.stringify(U));hostinterface.sendReply(JSON.stringify(U))}})}});break;default:console.log("Message not supported what="+v);console.log("APICallHandler: handleRequest: actionCode not supported");var E=new Result(constants.NativeCallResultCode.ERROR,{});O.resolve(E)}}console.log("End of API handler call");return O.promise()}};var i=function(k){var l={};var m=constants.NativeCallResultCode.ERROR;if(k instanceof Result){m=k.getType()}var n=new Result(m,l);return n};var a=function(k){var m={};var p=constants.NativeCallResultCode.ERROR;if(k instanceof Result){p=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){p=constants.NativeCallResultCode.SUCCESS;var l=[];var o=k.getResultMap()["achievements"];var n=o.achievements;$.each(n,function(s,t){var r={};var u=t.achievementMeta;var v=t.playerInfo;r.ACHIEVEMENT_ID=u.id;r.ACHIEVEMENT_TITLE=u.title;r.ACHIEVEMENT_DESCRIPTION=u.description;r.ACHIEVEMENT_POINTS=u.pointValue;r.ACHIEVEMENT_HIDDEN=u.hiddenValue;r.ACHIEVEMENT_UNLOCKED=v.unlocked;r.ACHIEVEMENT_UPDATE_PERCENT=v.progress;r.ACHIEVEMENT_POSITION=u.position;if(r.ACHIEVEMENT_UNLOCKED){r.ACHIEVEMENT_DATE_UNLOCKED=v.dateUnlocked}else{r.ACHIEVEMENT_DATE_UNLOCKED=0}l.push(r)});m[constants.AchievementsBindingKeys.ACHIEVEMENT_LIST_KEY]=l}}var q=new Result(p,m);return q};var h=function(k){var m={};var o=constants.NativeCallResultCode.ERROR;if(k instanceof Result){o=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){o=constants.NativeCallResultCode.SUCCESS;var n=k.getResultMap()["achievement"];var l=n.achievementMeta;var q=n.playerInfo;m[constants.AchievementsBindingKeys.ACHIEVEMENT_ID_KEY]=l.id;m[constants.AchievementsBindingKeys.ACHIEVEMENT_TITLE_KEY]=l.title;m[constants.AchievementsBindingKeys.ACHIEVEMENT_DESCRIPTION_KEY]=l.description;m[constants.AchievementsBindingKeys.ACHIEVEMENT_POINTS_KEY]=l.pointValue;m[constants.AchievementsBindingKeys.ACHIEVEMENT_HIDDEN_KEY]=l.hiddenValue;m[constants.AchievementsBindingKeys.ACHIEVEMENT_POSITION_KEY]=l.position;if(q!=null){m[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]=q.unlocked;m[constants.AchievementsBindingKeys.ACHIEVEMENT_UPDATE_PERCENT_KEY]=q.progress;if(m[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]){m[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=q.dateUnlocked}else{m[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=0}}}}var p=new Result(o,m);return p};var e=function(k){var m={};var n=constants.NativeCallResultCode.ERROR;if(k instanceof Result){n=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){n=constants.NativeCallResultCode.SUCCESS;var l=k.getResultMap()["newlyUnlocked"];m[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]=l}}var o=new Result(n,m);return o};var j=function(l){var n={};var o=constants.NativeCallResultCode.ERROR;if(l instanceof Result){o=l.getType();if(l.getType()==constants.NativeCallResultCode.SUCCESS){o=constants.NativeCallResultCode.SUCCESS;var m=[];var k=l.getResultMap()["LeaderboardList"];$.each(k,function(t,s){var q={};var r=s.LeaderboardInfo;q.LEADERBOARD_ID=r.LeaderboardId;q.LEADERBOARD_NAME=r.Name;q.LEADERBOARD_DISPLAY_TEXT=r.DisplayText;q.LEADERBOARD_DATA_FORMAT=r.DataFormat;m.push(q)});n[constants.LeaderboardBindingKeys.LEADERBOARD_LIST_KEY]=m}}var p=new Result(o,n);return p};var d=function(k){var l={};var o=constants.NativeCallResultCode.ERROR;if(k instanceof Result){o=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){o=constants.NativeCallResultCode.SUCCESS;var n=k.getResultMap()["PlayerScore"];var m=k.getResultMap()["PlayerRank"];l[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_SCORE_KEY]=n;l[constants.LeaderboardBindingKeys.LEADERBOARD_PLAYER_RANK_KEY]=m}}var p=new Result(o,l);return p};var f=function(y,r){var o={};var x=constants.NativeCallResultCode.ERROR;if(y instanceof Result){x=y.getType();if(y.getType()==constants.NativeCallResultCode.SUCCESS){x=constants.NativeCallResultCode.SUCCESS;var q=y.getResultMap()["LeaderboardInfo"];var t=y.getResultMap()["RankList"];var n=t.length;var p=q.DisplayText;var s=q.DataFormat;var l=q.Name;var k=q.LeaderboardId;var v=[];var u=r;var m=[];$.each(t,function(C,B){var D=u;var z=B.Score;var A=B.Username;var E={};E[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_VALUE_KEY]=z;E[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_RANK_KEY]=D;E[constants.LeaderboardBindingKeys.LEADERBOARD_KEY]=k;E[constants.ProfilesBindingKeys.ALIAS_KEY]=A;m.push(E);u++});o[constants.LeaderboardBindingKeys.LEADERBOARD_DISPLAY_TEXT_KEY]=p;o[constants.LeaderboardBindingKeys.LEADERBOARD_DATA_FORMAT_KEY]=s;o[constants.LeaderboardBindingKeys.LEADERBOARD_NAME_KEY]=l;o[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=k;o[constants.LeaderboardBindingKeys.LEADERBOARD_SCORES_ARRAY_KEY]=m}}var w=new Result(x,o);return w};var g=function(k){var p={};var q=constants.NativeCallResultCode.ERROR;if(k instanceof Result){q=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){q=constants.NativeCallResultCode.SUCCESS;var l=k.getResultMap()["LeaderboardInfo"];var o=k.getResultMap()["UserIndex"];var n=k.getResultMap()["PercentileList"];var m=[];$.each(n,function(u,w){var s=w.Percentile;var t=w.PlayerName;var x=w.PlayerScore;var v={};v.Percentile=s;v.PlayerName=t;v.PlayerScore=x;m.push(v)});p[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=l.LeaderboardId;p[constants.LeaderboardBindingKeys.LEADERBOARD_NAME_KEY]=l.Name;p[constants.LeaderboardBindingKeys.LEADERBOARD_DISPLAY_TEXT_KEY]=l.DisplayText;p[constants.LeaderboardBindingKeys.LEADERBOARD_DATA_FORMAT_KEY]=l.DataFormat;p[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILES_ARRAY_KEY]=m;p[constants.LeaderboardBindingKeys.LEADERBOARD_USER_INDEX_KEY]=o}}var r=new Result(q,p);return r};var b=function(k,p){var l={};var n=constants.NativeCallResultCode.ERROR;if(k instanceof Result){n=k.getType();if(k.getType()==constants.NativeCallResultCode.SUCCESS){n=constants.NativeCallResultCode.SUCCESS;var m=k.getResultMap()["SubmitScoreResultsList"];l[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_RESULT_KEY]=m}}var o=new Result(n,l);return o};return c}());console.log("APICallHandler loaded.");